module Event
  class ReportForRequest < Report
    self.description = 'Report for a request created'
    payload_keys :bs_request_number

    self.notification_explanation = 'Receive notifications for reported requests.'

    def subject
      "Request #{payload['bs_request_number']} reported"
    end
  end
end

# == Schema Information
#
# Table name: events
#
#  id          :bigint           not null, primary key
#  eventtype   :string(255)      not null, indexed
#  mails_sent  :boolean          default(FALSE), indexed
#  payload     :text(16777215)
#  undone_jobs :integer          default(0)
#  created_at  :datetime         indexed
#  updated_at  :datetime
#
# Indexes
#
#  index_events_on_created_at  (created_at)
#  index_events_on_eventtype   (eventtype)
#  index_events_on_mails_sent  (mails_sent)
#
